/* Copyright (c) 1997 L.W.McVoy */
#include "sccs.h"
WHATSTR("@(#)ci.c 1.29");

void	rcs(char *cmd, int ac, char **av, char **ev);

/*
 * RCS ci style interface to SCCS delta.
 * TODO: -d<date> -w<login>
 */
int
main(int ac, char **av, char **ev)
{
	sccs	*s;
	int	flags = BRANCHOK;
	int	c;
	char	*mArg = 0, *dArg = 0, *uArg = 0;
	delta	*d = 0;
	char	*name;

	debug_main(av);
	if (isdir("RCS") && !isdir("SCCS")) {
		rcs("ci", ac, av, ev);
		/* NOTREACHED */
	}
	if (ac > 1 && streq("--help", av[1])) {
usage:		fprintf(stderr,
		    "usage: %s [-fipsq] [-d<date>] [-m<comment>] [files...]\n",
		    av[0]);
		fprintf(stderr, "\t-f\tforce a delta\n"
				"\t-d\tset the date of the delta\n"
				"\t-i\tinitial checkin\n"
				"\t-m<c>\tcheck comment\n"
				"\t-p\tprint differences before checkin\n"
				"\t-q\tquiet\n"
				"\t-s\tquiet\n");
		return(1);
	}

	while ((c = getopt(ac, av, "d;fipsqm|w;y|")) != -1) {
		switch (c) {
		    /* RCS compatible flags */
		    case 'f': flags |= FORCE; break;
		    case 'q': flags |= SILENT; break;
		    case 'm': mArg = optarg; flags |= DONTASK; break;
		    case 'd': dArg = optarg; break;
		    case 'w': uArg = optarg; break;
		    case 'i': flags |= NEWFILE; break;

		    /* SCCS compatible flags */
		    case 'p': flags |= PRINT; break;
		    case 's': flags |= SILENT; break;
		    case 'y': flags |= DONTASK; mArg = optarg; break;

		    default:
			goto usage;
	    	}
		if (d && (d->flags == -1)) {
			sccs_freetree(d);
			goto usage;
		}
	}
	/* XXX - I need to wack this to not check for the s.file */
	for (name = sfileFirst("ci", &av[optind], GFILE|WRITABLE);
	    name; name = sfileNext()) {
		s = sccs_init(name, flags);
		if (!s) continue;
		if (mArg) d = sccs_parseArg(d, 'C', mArg); 
		if (dArg) d = sccs_parseArg(d, 'D', dArg);
		if (uArg) d = sccs_parseArg(d, 'U', uArg); 
		if (sccs_delta(s, flags, d, 0) == -1) {
			sccs_whynot("ci", s);
			return(1);
		}
		sccs_free(s);
		d = 0;
	}
	sfileDone();
	purify_list();
	return(0);
}
