/* Copyright (c) 1997 L.W.McVoy */
#include "sccs.h"
WHATSTR("@(#)co.c 1.24");

void	rcs(char *cmd, int ac, char **av, char **ev);

/*
 * Emulate RCS co.
 *
 * If no SCCS directory and there is an RCS directory, exec the RCS co.
 */
int
main(int ac, char **av, char **ev)
{
	sccs	*s;
	int	flags = (EXPAND|INHERIT);
	char	*rev = 0;
	int	c;
	char	*name;

	debug_main(av);
	if (isdir("RCS") && !isdir("SCCS")) {
		rcs("co", ac, av, ev);
		/* NOTREACHED */
	}
	if (ac > 1 && streq("--help", av[1])) {
usage:		fprintf(stderr,
		    "usage: %s [bklmpqu] [-r<r>] [files...]\n",
		    av[0]);
		fprintf(stderr, "\t-b\tforce a branch\n"
				"\t-k\tdon't expand keywords\n"
				"\t-l\tcheckout with lock for editing\n"
				"\t-p\tprint file to stdout\n"
				"\t-q\tquiet\n"
				"\t-r<r>\tuse revision <r>\n"
				"\t-m\tprefix each line with revision number"
				"\t-u\tprefix each line with user id\n");
		return(1);
	}
	while ((c = getopt(ac, av, "bklmpr;qu")) != -1) {
		switch (c) {
		    /* RCS options */
		    case 'k': flags &= ~(EXPAND|INHERIT); break;
		    case 'l': flags |= EDIT; break;
		    case 'p': flags |= PRINT; break;
		    case 'r': rev = optarg; break;
		    case 'q': flags |= SILENT; break;

		    /* Added options */
		    case 'm': flags |= REVNUMS; break;
		    case 'u': flags |= USER; break;
		    case 'b': flags |= FORCEBRANCH; break;
		    default:
			goto usage;
	    	}
	}
	if (flags & (REVNUMS|USER)) {
		flags &= ~EDIT;
	}
	if (flags & EDIT) {
		flags &= ~EXPAND;
	}
	for (name = sfileFirst("co",&av[optind], 0); name; name = sfileNext()) {
		s = sccs_init(name, flags);
		if (!s) continue;
		if (!s->tree) {
			if (!(s->state & SFILE)) {
				fprintf(stderr, "co: %s doesn't exist.\n",
				    s->sfile);
			} else {
				perror(s->sfile);
			}
			sccs_free(s);
			continue;
		}
		if (sccs_get(s, rev, 0, 0, flags, "-")) {
			unless (BEEN_WARNED(s)) {
				fprintf(stderr,
				    "co of %s failed, skipping it.\n",
				    s->gfile);
			}
		}
		sccs_free(s);
	}
	sfileDone();
	purify_list();
	return(0);
}
