#include "sccs.h"

#ifdef	MYMALLOC
#undef	malloc
#undef	calloc
#undef	free

#define	CHUNKSIZ	(256<<10)
typedef struct _M {
	char	*chunk;
	int	left;
	struct _M *next;
} list_t;

static list_t	*l;

void*
mymalloc(int size)
{
	list_t *new;

	if (size >= CHUNKSIZ) {
		new = (list_t*)malloc(sizeof(*new));
		new->next = l;
		new->chunk = malloc(size);
		assert(new->chunk);
		new->left = 0;
		if (!l) {
			l = new;
			new->next = 0;
			return (new->chunk);
		}
		/*
		 * Put it one down the list because the top might
		 * still have space.
		 */
		new->next = l->next;
		l->next = new;
		return (new->chunk);
	}
	if (l && (l->left >= size)) {
		char	*space = &l->chunk[CHUNKSIZ - l->left];
		l->left -= size;
		return (space);
	}
	new = (list_t*)malloc(sizeof(*new));
	new->chunk = malloc(CHUNKSIZ);
	new->left = CHUNKSIZ - size;
	new->next = l;
	l = new;
	return (new->chunk);
}

void*
mycalloc(int n, int size)
{
	char	*space = mymalloc(n * size);
	bzero(space, size);
	return (space);
}

freeall()
{
	while (l) {
		list_t	*back = l;
		free(l->chunk);
		l = l->next;
		free(back);
	}
}
#endif
