#ifndef	_PURIFY_H
#define	_PURIFY_H

/*
 * TODO - maintain statistics
 */
#if defined(PURIFY) || defined(FASTPURIFY)
#define	malloc(l)	purify_alloc(l, __FILE__, __LINE__)
#define	calloc(l,n)	purify_alloc((l)*(n), __FILE__, __LINE__)
#define	free(m)		purify_free((void*)m, __FILE__, __LINE__)
#define	strdup(s)	purify_strdup(s, __FILE__, __LINE__)
#define	fopen(f,m)	purify_fopen(f,m,__FILE__, __LINE__)
#define	fdopen(f,m)	purify_fdopen(f,m,__FILE__, __LINE__)
#define	freopen(f,m,s)	purify_freopen(f,m,s,__FILE__, __LINE__)
#define	fclose(f)	purify_fclose(f,__FILE__, __LINE__)
#define	popen(f,m)	purify_popen(f,m,__FILE__, __LINE__)
#define	pclose(f)	purify_pclose(f,__FILE__, __LINE__)
#define	open(p,m,f)	purify_open(p,m,f,__FILE__, __LINE__)
#define	creat(p,m)	purify_creat(p,m,__FILE__, __LINE__)
#define	close(f)	purify_close(f,__FILE__, __LINE__)
#define	dup(fd)		purify_dup(fd,__FILE__,__LINE__)
#define	dup2(o,n)	purify_dup2(o,n,__FILE__,__LINE__)
#define	pipe(fds)	purify_pipe(fds,__FILE__,__LINE__)

void	*purify_alloc(int, char *, int);
void	purify_free(void *, char *, int);
char	*purify_strdup(char *, char *, int);
void	purify_check(void);
int	purify_open(char *p, int mode, int flags, char *file, int line);
int	purify_creat(char *p, int mode, char *file, int line);
int	purify_close(int i, char *file, int line);
FILE	*purify_popen(char *name, char *mode, char *file, int line);
int	purify_pclose(FILE *f, char *file, int line);
FILE	*purify_fopen(char *name, char *mode, char *file, int line);
FILE	*purify_fdopen(int fd, char *mode, char *file, int line);
FILE	*purify_freopen(char *path, char *mode, FILE *ret,char *file, int line);
int	purify_fclose(FILE *f, char *file, int line);
void	purifyList(char *file, int line);
void	purifyCheck(char *file, int line);
void	purifyFiles(char *file, int line);

#define	purify_list()	purifyList(__FILE__, __LINE__)
#define	purify_check()	purifyCheck(__FILE__, __LINE__)
#define	purify_files()	purifyFiles(__FILE__, __LINE__)

#else

#define	purify_list()	
#define	purify_check()	
#define	purify_files()

#endif	/* PURIFY */

#endif	/* _PURIFY_H */
