/* @(#)sccs.h 1.90 Copyright (c) 1997 Larry McVoy */
#ifndef	_SCCS_H_
#define	_SCCS_H_
#include <assert.h>
#include <ctype.h>
#include <signal.h>
#include <stdio.h>
#include <strings.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <setjmp.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <sys/utsname.h>
#include <fcntl.h>
#include "purify.h"

#define	HAVE_GETDOMAINNAME
#ifdef	PROFILE
#define	private
#define	inline
#else
#define	private static
#endif
#if	defined(ANSIC)
#if	!defined(inline)
#define	inline
#endif

#define	isascii(x)	(((x) & ~0x7f) == 0)
#undef	HAVE_GETDOMAINNAME
extern	char *strdup(char *s);
#endif

/*
 * Local config starts here.
 */
#ifndef	SDIFF
#	define	SDIFF	"/usr/bin/sdiff"
#endif

/*
 * Define this to use GNU diff instead of built in diff.
 * This is currently the right answer, there are problems with the
 * builtin diff.
 */
#define	DIFF	"/usr/bin/diff"

/*
 * If you want to use stdio for all I/O, which is slightlu slower but
 * more portable, define this:
#define	USE_STDIO
 */

#if	(!defined(__GNUC__) || defined(DEBUG)) && !defined(inline)
#	define	inline
#endif
#ifdef	DEBUG
#	define	debug(x)	fprintf x
#else
#	define	debug(x)
#	define	debug_main(x)
#endif
#ifdef	DEBUG2
#	define	debug2(x)	fprintf x
#else
#	define	debug2(x)
#endif
#ifdef LINT
#	define	WHATSTR(X)	pid_t	getpid(void)
#else
#	define	WHATSTR(X)	static char *what = X
#endif
#define	max(a,b)	((a)>(b)?(a):(b))
#define	min(a,b)	((a)<(b)?(a):(b))
#define	bcopy(s,d,l)	memmove(d,s,l)
#define	bcmp(a,b,l)	memcmp(a,b,l)
#define	bzero(s,l)	memset(s,0,l)
#define	streq(a,b)	!strcmp(a,b)
#define	strneq(a,b,n)	!strncmp(a,b,n)
#define	index(s, c)	strchr(s, c)
#define	rindex(s, c)	strrchr(s, c)
#define	exists(f)	(access(f, F_OK) == 0)
#define	notnull(s)	(s ? s : "")
#define	unless(e)	if (!(e))
#define	verbose(x)	unless (flags&SILENT) fprintf x
#define fnext(buf, in)  fgets(buf, sizeof(buf), in)
#ifdef	USE_STDIO
#define next(buf, s)	fnext(buf, s->file)
#define	seekto(s,where)	fseek(s->file, (long)where, SEEK_SET)
#define	tell(s)		ftell(s->file)
#define	eof(s)		feof(s->file)
#define	peekc(c,s)	c = fgetc(s->file); ungetc(c, s->file)
#define	BUF(b)		char b[1024]
#else
#define next(buf, s)	(buf = fastnext(s))
#define	seekto(s,o)	s->where = (s->mmap + o)
#define	tell(s)		(s->where - s->mmap)
#define	eof(s)		(s->where >= s->mmap + s->size)
#define	peekc(c,s)	c = *s->where
#define	BUF(b)		char *b
#endif

/*
 * Flags that modify some operation (passed to sccs_*).
 */
#define	SILENT		0x00000001	/* do work quietly */
#define	EDIT		0x00000002	/* get -e: get for editting */
#define	EXPAND		0x00000004	/* expand keywords */
#define	REVNUMS		0x00000008	/* get -m: prefix each line with rev */
#define	PRINT		0x00000010	/* get/delta -p: [diffs] to stdout */
#define USER		0x00000020	/* get -u: prefix with user name */
#define SKIPGET		0x00000040	/* get -g: don't get the file */
#define	FORCE		0x00000080	/* delta -f: force a delta */
#define	SAVEGFILE	0x00000100	/* delta -n: save edited gfile */
#define	UNEDIT		0x00000200	/* clean -u: unedit - discard changes */
#define	NEWFILE		0x00000400	/* delta -i: create initial file */
#define	TIMET		0x00000800	/* prs -t */
#define	INHERIT_DATE	0x00001000	/* convert sdate -> date */
#define	NOCKSUM		0x00002000	/* don't do the checksum */
#define	FORCEBRANCH	0x00004000	/* force a branch when creating delta */
#define	CHECKFILE	0x00008000	/* check file format (admin) */
#define	NEWCKSUM	0x00010000	/* Redo checksum */
#define	RCSEXPAND	0x00020000	/* do RCS keywords */
#define	USEREV		0x00040000	/* use the rev passed into delta */
#define	TOP		0x00080000	/* use the top rev */
#define	INHERIT		0x00100000	/* set up the pointers */
#define	EMPTY		0x00200000	/* initialize with empty file */
#define	DONTASK		0x00400000	/* don't ask for comments */
#define	FORCEASCII	0x00800000	/* Do not gunzip/uudecode */
#define	MAP_WRITE	0x01000000	/* map the file read/write */
#define	MODNAME		0x02000000	/* get -n: prefix with %M */
#define	NODEFAULT	0x04000000	/* sccsid - no default pathname */
#define	PREFIX_DATE	0x08000000	/* get -d: show date */

/*
 * Flags (s->state) that indicate the state of a file.  Set up in init.
 * Also used for sccs_files() flags.
 */
#define	SFILE		0x00000001	/* s->sfile exists as a regular file */
#define	GFILE		0x00000002	/* s->gfile exists as a regular file */
#define	PFILE		0x00000004	/* SCCS/p.file exists */
#define	ZFILE		0x00000008	/* SCCS/z.file exists */
#define	WRITABLE	0x00000010	/* s->gfile is writable */
#define	SOPEN		0x00000020	/* s->sfile is open */
#define	SEXECUTABLE	0x00000040	/* s->sfile is executable */
#define	GEXECUTABLE	0x00000080	/* s->gfile is executable */
#define	WARNED		0x00000100	/* error message already sent */
#define	KEYWORDS	0x00000200	/* last line gotten has %x% */
#define EDITED		(SFILE|PFILE|GFILE|WRITABLE)
#define	RCS		0x00000400	/* expand RCS keywords */
#define	BRANCHOK	0x00000800	/* branching allowed */
#define	NOEXPAND	0x00001000	/* don't auto expand in sccs_files */
#define	CHMOD		0x00002000	/* change the file back to 0444 mode */
#define	YEAR4		0x00004000	/* print out the year as 4 digits */

/*
 * Options to sccs_diffs()
 */
#define	D_DIFF		'd'
#define	D_SDIFF		's'
#define	D_CONTEXT	'c'
#define	D_UNIFIED	'u'

/*
 * Date handling.
 */
#define	ROUNDUP	1
#define	EXACT	0
#define	ROUNDDOWN -1
#define	DATE(d)	(d->date ? d->date : getDate(d))

/*
 * Bits for the x flag in the s.file.
 */
#define	X_RCSEXPAND	0x00000001	/* RCS keywords */
#define	X_YEAR4		0x00000002	/* 4 digit years */

/*
 * Encoding flags.
 */
#define	E_ASCII		0		/* no encoding */
#define	E_UUENCODE	1		/* uuenecode it (traditional) */
#define	E_UUGZIP	2		/* gzip and uuencode */

#define	HAS_GFILE(s)	((s)->state & GFILE)
#define	HAS_PFILE(s)	((s)->state & PFILE)
#define	HAS_ZFILE(s)	((s)->state & ZFILE)
#define	HAS_SFILE(s)	((s)->state & SFILE)
#define	BEEN_WARNED(s)	((s)->state & WARNED)
#define	IS_WRITABLE(s)	((s)->state & WRITABLE)
#define IS_EDITED(s)	(((s)->state & EDITED) == EDITED)
#define	IS_SEXEC(s)	((s)->state & SEXECUTABLE)
#define	IS_GEXEC(s)	((s)->state & GEXECUTABLE)

#define	GOODSCCS(s)	assert(s); unless (s->tree && s->cksumok) return (-1)

/*
 * Flags (d->flags) that indicate some state on the delta.
 */
#define	DERROR		0x00000001	/* from parseArg() */
#define	NOHOST		0x00000002	/* don't generate a hostname */
#define	NOPATH		0x00000004	/* don't generate a pathname */
#define	NOZONE		0x00000008	/* don't generate a time zone */
#define	NOSTATE		0x00000010	/* don't generate state field */
#define	NOCOMMENTS	0x00000020	/* don't generate comments */
#define	DMATCH		0x00000040	/* delta has a match (smoosh) */
#define	DUPHOST		0x00000080	/* this host pointer is shared */
#define	DUPPATH		0x00000100	/* this path pointer is shared */
#define	DUPZONE		0x00000200	/* this zone pointer is shared */
#define	DUPSTATE	0x00000400	/* this state pointer is shared */
#define	BRANCH		0x00000800	/* this delta wants to be the root
					 * of a branch, not a child of the
					 * parent's LOD.  */
#define	BADREV		0x00001000	/* poorly formed rev */
#define	DSTEAL		0x00002000	/* sccslog is stealing this rev */

/*
 * Signal handling.
 * Caught signals do not restart system calls.
 */
#define	CATCH		0x0001		/* catch the specified signal */
#define	BLOCK		0x0002		/* block the signal */
#define	UNBLOCK		0x0004		/* block the signal */
#define	PENDING		0x0008		/* check for pending signal */
#define	UNCATCH		0x0010		/* restore old handler */
#define	CAUGHT		0x0020		/* has this signal been caught? */
#define	CLEAR		0x0040		/* forget about past catches */

#define	MAXREV	24	/* 99999.99999.99999.99999 */

#define	SCCSTMP "SCCS/T.SCCSTMP"

typedef	unsigned short	ser_t;
typedef	unsigned short	sum_t;

/*
 * Struct delta - describes a single delta entry.
 *
 * If we have a tree like so:
 * 1.1	1.2	1.3
 *      1.1.1.1
 * and we are rev 1.2, then our parent is to 1.1, our kid is 1.3,
 * and our sibling is 1.1.1.1.
 *
 * Note: we don't implement MRs - should we?
 */
typedef struct delta {
	/* stuff in original SCCS */
	int	added;			/* lines added by this delta */
	int	deleted;		/* and deleted */
	int	same;			/* and unchanged */
	char	type;			/* Delta or removed delta */
	char	*rev;			/* revision number */
	char	*sdate;			/* ascii date in local time, i.e.,
					 * 93/07/25 21:14:11 */
	char	*user;			/* user name of delta owner */
	ser_t	serial;			/* serial number of this delta */
	ser_t	pserial;		/* serial number of parent */
	ser_t	*include;		/* include serial #'s */
	ser_t	*exclude;		/* exclude serial #'s */
	ser_t	*ignore;		/* ignore serial #'s */
	char	**comments;		/* Comment log */
	/* New stuff in lm's sccs */
	char	*hostname;		/* hostname where revision was made */
	char	*pathname;		/* pathname to the file */
	char	*zone;			/* 08:00 is time relative to GMT */
	char	*state;			/* RCS state value */
	/* In memory only stuff */
	int	r[4];			/* 1.2.3 -> 1, 2, 3, -1 */
	time_t	date;			/* date - conversion from sdate/zone */
	struct	delta *parent;		/* parent delta above me */
	struct	delta *kid;		/* next delta on this branch */
	struct	delta *siblings;	/* pointer to other branches */
	struct	delta *next;		/* all deltas in table order */
	struct	delta *link;		/* link to a matcing delta (smoosh) */
	int	flags;			/* per delta flags */
} delta;

/*
 * See slib.c:allocstate() for explanation.
 */
#define	SFREE	1
#define	SLIST	0
typedef struct serial {
	struct	serial *next;		/* forward & */
	struct	serial *prev;		/* ... back links when allocated */
	ser_t	serial;			/* # we're working on */
	char	type;			/* 'I' or 'E' */
} serlist;

#define	S_INC	1
#define	S_EXCL	2
typedef struct {
	ser_t	ser;			/* serial number that set ... */
	short	what;			/* ... this to S_INC|S_EXCL */
} ielist;

typedef	struct symbol {			/* RCS style symbolic tags */
	char	*name;			/* STABLE */
	char	*rev;			/* 1.32 */
	struct	symbol *next;		/* list rooted at sccs struct */
} symbol;

/*
 * struct sccs - the delta tree, the data, and associated junk.
 */
typedef	struct sccs {
	delta	*tree;		/* the delta tree after mkgraph() */
	delta	*table;		/* the delta table list */
	delta	*lastinsert;	/* pointer to the last delta inserted */
	symbol	*symbols;	/* RCS style symbolic tags */
	char	*defbranch;	/* defbranch, if set */
	int	numdeltas;	/* number of entries in the graph */
	delta	**ser2delta;	/* indexed by serial, returns delta */
	int	ser2dsize;	/* just to be sure */
#ifdef	USE_STDIO
	FILE	*file;		/* open to ... */
#else
	char	*mmap;		/* mapped file */
	char	*where;		/* where we are in the mapped file */
	off_t	size;		/* size of mapping */
	char	*landingpad;	/* some space for symbols */
#endif
	int	fd;		/* cached copy of the file descriptor */
	char	*sfile;		/* SCCS/s.foo.c */
	char	*pfile;		/* SCCS/p.foo.c */
	char	*zfile;		/* SCCS/z.foo.c */
	char	*gfile;		/* foo.c */
	char	**usersgroups;	/* lm, beth, staff, etc */
	int	encoding;	/* ascii, uuencode, gzip, etc. */
	char	**flags;	/* flags in the middle that we didn't grok */
	char	**text;		/* descriptive text */
	int	state;		/* GFILE/SFILE etc */
	off_t	data;		/* offset to data in file */
	int	nextserial;	/* next unused serial # */
	delta	*rstart;	/* start of a range */
	delta	*rstop;		/* end of range */
	unsigned short cksum;	/* SCCS chksum */
	unsigned int cksumok:1;	/* check sum was ok */
} sccs;

typedef struct {
	int	flags;		/* ADD|DEL|FORCE */
	char	*thing;		/* whatever */
} admin;
#define	A_SZ		20	/* up to 20 adds/deletes of a single type */
#define	A_ADD		0x0001
#define	A_DEL		0x0002

/*
 * Passed back from read_pfile().
 */
typedef struct {
	char	oldrev[MAXREV];
	char	newrev[MAXREV];
	char	*user;			/* malloced - caller frees */
	char	date[20];
	char	*iLst;			/* malloced - caller frees */
	char	*xLst;			/* malloced - caller frees */
} pfile;

/* getopt stuff */
#define getopt	mygetopt
#define optind	myoptind
#define optarg	myoptarg
#define	opterr	myopterr
#define	optopt	myoptopt
extern	int	optind;
extern	int	opterr;
extern	int	optopt;
extern	char	*optarg;
int	getopt(int ac, char **av, char *opts);

int	sccs_admin(sccs *sc, int flags,
            admin *f, admin *u, admin *s, admin *p, char *text);
int	sccs_checkin(sccs *s, int flags, delta *d);
int	sccs_delta(sccs *s, int flags, delta *d, char *prsfile);
int	sccs_diffs(sccs *s, char *r1, char *r2, int flags, char kind);
int	sccs_get(sccs *s, char *rev, char *i, char *x, int flags, char *out);
int	sccs_clean(sccs *s, int flags);
int	sccs_info(sccs *s, int flags);
int	sccs_prs(sccs *s, int flags, FILE *out);
delta	*sccs_getrev(sccs *s, char *rev, char *date, int roundup);
sccs	*sccs_init(char *filename, int flags);
sccs	*sccs_restart(sccs *s);
void	sccs_free(sccs *);
void	sccs_freetree(delta *);
char	**sccs_files(char **, int);
void	sccs_freefiles();
int	sccs_smoosh(char *left, char *right);
delta	*sccs_parseArg(delta *d, char what, char *arg);
void	sccs_whynot(char *who, sccs *s);
int	sccs_addSym(sccs *, int, char *);
time_t	sccs_date2time(char *date, char *zone, int roundup);
void	sccs_id(sccs *s, int flags, FILE *out);
void	sfileUnget(void);
char	*sfileNext(void);
char	*sfileFirst(char *cmd, char **Av, int Flags);
void	sfileDone(void);
void	rangeReset(sccs *sc);
int	rangeAdd(sccs *sc, char *rev, char *date);
int	tokens(char *s);
delta	*findrev(sccs *, char *);

FILE	*fastPopen(const char*, const char*);
int	fastPclose(FILE*);
void	chop(register char *s);
int	is_sccs(char *name);
int	isdir(char *s);
int	isreg(char *s);
int	readable(char *f);
int	writable(char *f);
int	executable(char *f);
char	*sccs2name(char *);
char	*name2sccs(char *);
int	diff(char *lfile, char *rfile, char kind, char *out);
char	**addLine(char **space, char *line);
int	roundType(char *r);
sccs	*check_gfile(sccs*, int);
#endif	/* _SCCS_H_ */
