/*
 * Generate unique id's for the specified list of files.
 *
 * XXX - this should be part of sccslog
 * XXX - todo - allow selection of LOD's and/or revisions
 * Copyright (c) 1997 L.W.McVoy
 */
#include "sccs.h"
WHATSTR("@(#)sccsids.c 1.6");

int
main(int ac, char **av)
{
	sccs	*s;
	char	*name;
	int	c;
	int	flags = 0;

	debug_main(av);
	while ((c = getopt(ac, av, "f")) != -1) {
		switch (c) {
		    case 'f': flags |= NODEFAULT|TOP; break;
		    default:
			fprintf(stderr, "sccsid: usage error, try --help.\n");
			return (1);
		}
	}
	for (name = sfileFirst("sccsid", &av[optind], 0);
	    name; name = sfileNext()) {
		s = sccs_init(name, flags|NOCKSUM|INHERIT);
		if (!s) continue;
		if (!s->tree) {
			if (!(s->state & SFILE)) {
				fprintf(stderr, "sccsid: %s doesn't exist.\n",
				    s->sfile);
			} else {
				perror(s->sfile);
			}
			sccs_free(s);
			continue;
		}
		sccs_id(s, flags, stdout);
		sccs_free(s);
	}
	sfileDone();
	purify_list();
	return(0);
}
