/* Copyright (c) 1997 L.W.McVoy */
#include "sccs.h"
WHATSTR("@(#)sids.c 1.13");

int
main(int ac, char **av)
{
	sccs	*s = 0;
	delta	*d;
	int	c;
	int	parent = 0;
	char	*name;

	debug_main(av);
	if (ac > 1 && streq("--help", av[1])) {
usage:		fprintf(stderr, "usage: %s [-p] [files...]\n", av[0]);
		fprintf(stderr, "\t-p\tlist parent revs\n");
		return(1);
	}
	while ((c = getopt(ac, av, "p")) != -1) {
		switch (c) {
		    case 'p': parent = 1; break;
		    default: goto usage;
	    	}
	}
	for (name = sfileFirst("sids", &av[optind], 0);
	    name; name = sfileNext()) {
		s = sccs_init(name, 0);
		if (!s) continue;
		unless (s->tree) {
			fprintf(stderr, "%s: can't read SCCS info in \"%s\".\n",
			    av[0], s->sfile);
			sfileDone();
			return(1);
		}
		printf("%s: ", s->gfile);
		for (d = s->table; d; d = d->next) {
			if (d->type != 'D') continue;
			if (parent) {
				printf("%s %s ",
				    d->parent ? d->parent->rev : "1.1", d->rev);
			} else {
				printf("%s ", d->rev);
			}
		}
		printf("\n");
		sccs_free(s);
	}
	sfileDone();
	purify_list();
	return (0);
}
